/*
 * $Id: clihdrtables.c $
 *
 * Author: Tomi Ollila <too@iki.fi>
 *
 * Created: Sat Aug  8 15:50:16 1998 too
 * Last modified: Wed Aug 26 17:53:52 1998 too
 *
 * HISTORY
 * $Log: $
 */

#include "clihdrtables.h"

#define SL_(x) { x, sizeof x - 1 }

struct String clihdrtable[] = { /* same order than in enum list in hdr file */
  SL_(""), /* placeholder */
  SL_("GET "),
  SL_("POST "),
  SL_("Referer: "),
  SL_("Connection: "),
  SL_("User-Agent: "),
  SL_("Host: "),
  SL_("Accept: "),
  SL_("Accept-Language: "),
  SL_("Accept-Charset: "),
  SL_("Content-type: "),
  SL_("Content-length: "),
#if 0
  SL_(""),
#endif
};

#ifdef DEBUG
const int size_clihdrtable = sizeof clihdrtable / sizeof clihdrtable[0];
#endif

#define SL(x) x, sizeof x - 1

struct StringMap clihdrmaptable[] = {
#if 0
  { SL(" "), CM_ },
#endif
  /*
   * must be in alphaphetical order.
   */
  { SL("Accept-Charset: "), CM_ACCHAR },
  { SL("Accept-Language: "), CM_ACCLANG },
  { SL("Accept: "), CM_ACCEPT },
  { SL("Connection: "), CM_CONN },
  { SL("Content-length: "), CM_CONLEN },
  { SL("Content-type: "), CM_CONTYPE },
  { SL("GET "), CM_GET },
  { SL("Host: "), CM_HOST },
  { SL("POST "), CM_POST },
  { SL("Referer: "), CM_REFERER },
  { SL("User-Agent: "), CM_USERAGENT },
};

const int clihdrmaptablelen = sizeof clihdrmaptable / sizeof clihdrmaptable[0];
