#include "project.h"

RCID("$Id: connection.c $");
/*
 * Author: Tomi Ollila <too@iki.fi>
 *
 * Created: Thu Jul  2 18:32:04 1998 too
 * Last modified: Thu Sep 10 20:21:04 1998 too
 *
 * HISTORY
 * $Log: $
 */

#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "connection.h"

/*
 * Create and initialize a new connection structure
 */
Connection * newConnection()
{
#ifdef DEBUG
  static int count = 1;
#endif
  Connection * c = (Connection *)malloc(sizeof (Connection));

  if (c)
  {
    memset(c, 0, sizeof *c);
#ifdef DEBUG
    c->count = count++;
#endif
    c->serrd.fd = c->clird.fd = -1;
  }

  TRACEF(TRCF_FUNCEXIT, ("c = %p = newConnection()\n", c));

  return c;
}

/*
 * finalize a connection structure
 */
void deleteConnection(Connection * c)
{
  TRACEF(TRCF_FUNCENTRY, ("deleteConnection(c = %p)\n", c));

#ifdef SHOWHDRS
  #define conn c
  WriteCS(1, "\n-#-# deleting conn "); PRTCONNID();
  #undef conn
#endif  

  /* abort, if any */
  nb_AbortReadReq(&c->clird);
  nb_AbortWriteReq(&c->cliwr);

  nb_AbortReadReq(&c->serrd);
  nb_AbortWriteReq(&c->serwr);

  if (c->clird.fd >= 0)	nb_CloseFd(c->clird.fd);
  if (c->bufstart)	freeDataBuffer(c->bufstart);

  if (c->serrd.fd >= 0)	nb_CloseFd(c->serrd.fd);
/*  if (c->ser.bufstart)	freeDataBuffer(c->ser.bufstart); */

  free(c);
}

#include <list.h>

static List databuffers = { (Node *)&databuffers.lh_Tail,
			    0, (Node *)&databuffers.lh_Head };
static int  freebuffers = 0;

#if 0
void initDataBuffers()
{
  newList(&databuffers);
}
#endif

char * getDataBuffer()
{
  if (freebuffers) {
    freebuffers--;
    return (char *)remHead(&databuffers);
  }
  return (char *)malloc(DBUFSIZE);
}

void freeDataBuffer(char * p)
{
  if (freebuffers >= 32)
    free(p);

  freebuffers++;
  addTail(&databuffers, (Node *)p);
}
