/*
 * $Id: localreplies.h $
 *
 * Author: Tomi Ollila <too@iki.fi>
 *
 * Created: Fri Aug  7 18:30:05 1998 too
 * Last modified: Sat Sep 12 18:43:34 1998 too
 *
 * HISTORY
 * $Log: $
 */

#ifndef LOCALREPLIES_H
#define LOCALREPLIES_H

#ifndef CONNECTION_H
#include "connection.h"
#endif

/* in messages_en.c  */

char * httpReplyCode(char * buf, char * p);

/* enumeration ... */
enum { RM_MAINPAGE,
#if 1       
       RM_NOMSG,	/* for messages that are not written yet */
#endif       
       RM_NOLOCALPAGE,
       RM_BADREQUEST,
       RM_FILENOTFOUND,
       RM_TOOLONGHEADER,
       RM_TOOLONGURL,
       RM_NOSUCHHOST,
       RM_TRASHEDHEADER,
       RM_NOHOSTHEADER,
       RM_SYSERR,
       RM_HOSTNOTFOUND,
       RM_CONNFAILED,
       RM_INVALIDURL,
       RM_TOOLONGCONTENT,
       RM_LOCNOHTTP,
       RM_SIZE };

struct LanguageFunctions
{
  char * (*getTitleH1)(int mi, int * titlen);
  char * (*addBody)(int mi, Connection * conn, char * p /*, ... ? */ );
};

void   localHttpReply(Connection * conn, int mi);
void   localHttpReplySysErr(Connection * conn, char * f, int errno);
#if 1
void   localHttpReplyX(Connection * conn, char * xcode);
#endif

char * redirect_start(Connection * conn);
void   redirect(Connection * conn, char * url, char * buf);

void   noHttp1x(Connection * conn);

char * writeUserAgent(char * info, Connection * conn, char * buf);
char * writeSystemInfo(Connection * conn, char * buf);


#ifdef DEBUG
void showDataOnPage(Connection * conn, char * data, int dlen);
#endif

/*
 * Currently a fast hack to deliver error values
 */
#define ERRSTR conn->u1.err.errstr
#define ERRVAL conn->u1.err.errval



#endif /* LOCALREPLIES_H */
