#!/bin/sh -e
# $Id: makelauncher.sh $
#
# Author: Tomi Ollila <Tomi.Ollila@iki.fi>
#
# Created: Thu Sep 10 18:09:40 1998 too
# Last modified: Sun Sep 13 10:55:35 1998 too
#
# HISTORY 
# $Log: $

# This file is created since there is too many differences between 
# make -commands. For example, GNU make does not support TARGET:= ...
# And, additionally this reduces complexity of a makefile a bit.

# Using autoconf might be a smarter mode, but starting ad-hoc development
# is easier w/ this kind of system ;)

# Tweak GNU make (and others ?)
[ x$MAKELEVEL = x1 -a x$MAKELAUNCHER != x1 ] && MAKELEVEL=0
MAKELAUNCHER=1; export MAKELAUNCHER

[ x$1 = x-n ] && { TE=echo; shift; } || TE=

# Check that both args are given (actually, check for $2 would suffice)
#[ ! $1 ] || [ ! $2 ] && { echo "Usage: %0 make-cmd trg-options"; exit 1; }
[ ! $3 ] && { echo "Usage: %0 maketrg target make-cmd [make-flags]"; exit 1; }

CMD=$0
TARGET=$1
MAKETRG=$2
MAKE=$3
MFLAGS=$4

#[ $MFLAGS ] && shift 4 || shift 3

# add here last platform check routine (with yes/no/abort)...


# go to end-of-file to find the main routine.

rununame() # arg 1 == uname option, arg 2 == default if uname fails (optional).
{
    uname $1 2>/dev/null

    [ $? = 0 ] && return

    [ $2 ] && { echo $2; return 0; }

    uname $1 # get uname failure message

    echo "Your architecture does not support \`uname\' command or" >&2
    echo "\`uname\' command does not support argument \`$i\'."  >&2
    echo "Add a special target to  \`$CMD\' to temporarily"  >&2
    echo "Support your system"  >&2
    exit 1
}


default()
{
    XLFLAGS=

    OS=`rununame -s`
    OS=`echo $OS | tr a-z A-Z`

    MACH=`rununame -m unknown`
    MACH=`echo $MACH | tr a-z A-Z`

#    VERS=`rununame -r 0.0`
#    set `echo $VERS | tr . ' '`
    set `rununame -r 0.0 | tr . ' '`

    case $OS in
	LINUX) 
	    ;;
	SUNOS)
	    [ $1 -eq 5 ] && XLFLAGS="-lsocket -lnsl"
	    ;;
	*)
	    echo $0: $OS -- unsupported target. Please add it.
	    ;;
    esac

    [ $1 ] && { XCFLAGS="-DOS_MAJOR=$1"
    [ $2 ] && { XCFLAGS="$XCFLAGS -DOS_MINOR=$2"
    [ $3 ] && { XCFLAGS="$XCFLAGS -DOS_MICRO=$3"
    };};}

    XCFLAGS="-DOS_$OS -DMACH_$MACH $XCFLAGS"

    if [ "$XLFLAGS" ]
    then
	echo $TE $MAKE $MFLAGS "XCFLAGS=$XCFLAGS" "XLFLAGS=$XLFLAGS" $MAKETRG
	exec $TE $MAKE $MFLAGS "XCFLAGS=$XCFLAGS" "XLFLAGS=$XLFLAGS" $MAKETRG
    else
	echo $TE $MAKE $MFLAGS "XCFLAGS=$XCFLAGS" $MAKETRG
	exec $TE $MAKE $MFLAGS "XCFLAGS=$XCFLAGS" $MAKETRG
    fi
}

#
#  Main
#
case $TARGET in
    .DEFAULT)
#	default $*
	default
	;;
    *)
	echo $CMD: $TARGET -- unknown target.
	;;
esac


#EOF
