#include "project.h"

RCID("$Id: messages_en.c $");
/*
 * Author: Tomi Ollila <too@iki.fi>
 *
 * Created: Fri Aug  7 18:21:04 1998 too
 * Last modified: Mon Sep  7 19:53:34 1998 too
 *
 * HISTORY
 * $Log: $
 */

#include <ctype.h>

#include "messages_en.h"
#include "userlog.h"

/* **************** Main Page **************** */

static char mainpage[] = "<FORM action='go' method=post>
<H2>Enter Destination URL</H2>
<table>
<tr><td>Go To:
<td><input type=text size=40 name=url>
<td colspan=4><input type=submit value=go>

<tr><td><td>Send Referer information
    <td><input type=radio name=ref value=x checked><td>yes
    <td><input type=radio name=ref value=r><td>no
    <td><input type=radio name=ref value=R><td>tricky
</table>
<hr>
<i>Tricky</i> in refer information means that `Referer:' header
is sent when new page is in the same server as the referer
page.
";

/* **************** **** **** **************** */

/* !!! katso kamaa src1/localpages.c:sta */

#define SL(x) data = x; len = sizeof x - 1


#if 0
/* Someday, check these codes (400, 404 etc) */
/* someday this should be solved a different way... eases adding things */
char * httpReplyCode(int mi, char * buf)
{
  char * data;
  int len;

  switch (mi)
  {
  case RM_MAINPAGE:
    SL("200 Found");
    break;
  case RM_NOMSG:
    SL("404 NO Message");
    break;
  case RM_NOLOCALPAGE:
    SL("404 Page Not Found");
    break;
  case RM_BADREQUEST:
    SL("400 Bad Request");
    break;
  case RM_FILENOTFOUND:
    SL("404 File Not Found");
    break;
  case RM_TOOLONGHEADER:
    SL("404 Too Long Header");
    break;
  case RM_TOOLONGURL:
    SL("404 Too Long Url");
    break;
  case RM_NOSUCHHOST:
    SL("404 No Such Host");
    break;
  case RM_TRASHEDHEADER:
    SL("404 Corrupted Header");
    break;
  case RM_NOHOSTHEADER:
    SL("404 Host Header Missing");
    break;
  case RM_SYSERR:
    SL("404 System Error");
    break;
#if 0    
  case RM_:
    break;
#endif    
  default:
    SL("200 x");
  }
  memcpy(buf, data, len);
  return buf + len;
}
#endif

/* XXX preliminary... and move to localreplies.c later */
char * httpReplyCode(char * buf, char * p)
{
  if (!isdigit(*p))
  {
    CSTPCPY(buf, "200 OK");
    return buf;
  }

  switch (*p - '0')
  {
  case 4:
    if (p[2] == '4')
      CSTPCPY(buf, "404 foobar");
    else
      CSTPCPY(buf, "400 barfoo");
    break;
  default:
    CSTPCPY(buf, "500 what!");
    break;
  }
  return buf;
}


/* Someday, check these codes (400, 404 etc) */
char * getTitleH1_en(int mi, int * titlen)
{
  char * data;
  int len;

  switch (mi)
  {
  case RM_MAINPAGE:
    SL("HTTPGate Launch Page");
    break;
  case RM_NOMSG:
    SL("404 Error Message not available");
    break;
  case RM_NOLOCALPAGE:
    SL("400 Local Page Not Found");
    break;
  case RM_BADREQUEST:
    SL("400 Bad Request");
    break;
  case RM_FILENOTFOUND:
    SL("404 File Not Found");
    break;
  case RM_TOOLONGHEADER:
    SL("404 Header Too Long");
    break;
  case RM_TOOLONGURL:
    SL("404 URL Too Long");
    break;
  case RM_NOSUCHHOST:
    SL("404 No Such Host");
    break;
  case RM_TRASHEDHEADER:
    SL("404 Corrupted header");
    break;
  case RM_NOHOSTHEADER:
    SL("404 Host: Header Missing");
    break;
  case RM_INVALIDURL:
    SL("404 Invalid URL");
    break;
  case RM_TOOLONGCONTENT:
    SL("404 Too Long Content");
    break;
  case RM_LOCNOHTTP:
    SL("404 No destination");
    break;
  case RM_CONNFAILED:
    SL("404 Connection failed");
    break;
  case RM_SYSERR:
    SL("System Error");
    break;
#if 0    
  case RM_:
    break;
#endif    
  default:
    SL("Missing HTTPGate Reply Message");
  }

  *titlen = len;
  return data;
}
  
char * addBody_en(int mi, Connection * conn, char * buf)
{
  char * data;
  int len;

  switch (mi)
  {
  case RM_MAINPAGE:
    buf = writeUserAgent("You are using: ", conn, buf);
#if 1    
    SL(mainpage);
    break;
#else    
    memcpy(buf, mainpage, sizeof mainpage - 1);
    return buf + sizeof mainpage_b - 1;
#endif

#if 1
  case RM_NOMSG:
    SL("The message for this error has not been added into HTTPGate "
       "since developers have been busy implementing the functionality "
       "of the program\n<p>\n"
       "\"Descriptive\" C macro definition for this message is: <i>");

    memcpy(buf, data, len);
    buf += len;
    buf = stpcpy(buf, ERRSTR);
    SL("</i>");
    break;
#endif
    
case RM_NOLOCALPAGE:
    SL("Your query were interpreted as a local page which"
	    "is not found on this server");
    break;
  case RM_BADREQUEST:
    SL("Your browser sent a request that this server could not understand.");
    break;
  case RM_FILENOTFOUND:
    SL("The requested URL was not found on this server.");
    break;
  case RM_TOOLONGHEADER:
    SL("Your request had longer header HTTPGate can handle.");
    break;
  case RM_TOOLONGURL:
    SL("Given URL overflows HTTPGate buffers");
    break;
  case RM_NOSUCHHOST:
    SL("Host name lookup failure");
    break;
  case RM_TRASHEDHEADER:
    SL("Client HTTP header error");
    break;
  case RM_NOHOSTHEADER:
    SL("For Proper operation, HTTPGate requires that"
	"browser supplies <I>Host:</I> header");
    break;
  case RM_INVALIDURL:
    SL("The requested URL is not understandable by HTTPGate gateway");
    break;
  case RM_TOOLONGCONTENT:
    SL("The request size is bigger that HTTPGate can safely handle");
    break;
  case RM_LOCNOHTTP:
    SL("Destination URL missing in request");
    break;
  case RM_CONNFAILED:
    CSTPCPY(buf, "Connection to the requested host failed.<br>Reason:");
    { extern char * sys_errlist[];
    buf = stpcpy(buf, sys_errlist[ERRVAL]); }
    return buf;
    
  case RM_SYSERR:
    buf = stpcpy(buf, ERRSTR); /* hack,  */
    *buf++ = ':';
    *buf++ = ' ';
    { extern char * sys_errlist[];
    buf = stpcpy(buf, sys_errlist[ERRVAL]); }
    return buf;
#if 0    
  case RM_:
    break;
#endif    
  default:
    userlog(ULOG_ERR, "Missing definition on replyHttpPage()\n");
    SL("This message appeared due to some inconsistensies in HTTPGate "
       "local messaging system<p>\n"
       "This error has been logged and should be corrected soon.");
  }
  memcpy(buf, data, len);
  return buf + len;
}

struct LanguageFunctions languagefunctions_en = { getTitleH1_en, addBody_en };
