/*
 * $Id: misc.c $
 *
 * Author: Tomi Ollila <Tomi.Ollila@iki.fi>
 *
 * Created: Thu Jul 16 17:20:33 1998 too
 * Last modified: Mon Sep  7 19:54:32 1998 too
 *
 * HISTORY
 * $Log: $
 */

#include <string.h>

static int hex2char(char * p);

/* decode www-urlencoded and copy (can copy overlapping areas if dst < src) */

int duecopy(char * dst, char * src)
{
  char * p = dst;
  int v;
  char c;
  int i = 0;

  while (*src == ' ' || *src == '\t' || *src == '+')
    src++;

  while ((c = *src++) != '&' && c /* !isspace(c) */)
  {
    if (c == '%' && (v = hex2char(src)) > 0)
    {
      c = v;
      src += 2;
    }
    else if (c == '+')
      c = ' ';

    *dst++ = c;

    if (i++ == 6 && strncasecmp(p, "http://", 7) == 0)
      dst = p;
  }

  return dst - p;
}

static int hex2char(char * p)
{
  unsigned int c1 = p[0];
  unsigned int c2 = p[1];

  if (c1 <= '9') c1 -= '0';
  else if (c1 <= 'F') c1 -= 'A' - 10;
  else c1 -= 'a' - 10;

  if (c1 > 15)
    return -1;

  if (c2 <= '9') c2 -= '0';
  else if (c2 <= 'F') c2 -= 'A' - 10;
  else c2 -= 'a' - 10;

  if (c2 > 15)
    return -1;

  return c1 * 16 + c2;
}
