/*
 * $Id: nb_resolve.c $
 *
 * Author: Tomi Ollila <Tomi.Ollila@iki.fi>
 *
 * Created: Thu Aug 20 19:52:42 1998 too
 * Last modified: Mon Sep  7 19:57:38 1998 too
 *
 * HISTORY 
 * $Log: $
 */

/*
 * Currently blocks... won't do that in future...
 * In the future, this file will contain code that
 * sends a request w/ nb_SendWriteReq(),
 * receives a reply sometime after calls nb_SendReadReq()
 * and, when got all necessary data, will resolve the
 * address there and call nb_SendReplyMsg().
 *
 * MORE NOTES: when handling anynchronous nameserver queries,
 * cache the entry already, but with a `pending' flag up, so
 * if there is more queries to the same host, those will be put into
 * a queue waiting for the first one to resolve.
 */

#include <string.h>
#include <netinet/in.h>
#include <netdb.h>

#include "nbcore.h"
#include "nb_extensions.h"

/* single element cache for one hostname + its address */
/* make a bigger cache w/ ttl information also later */

/* anyhbody knows pd implementation of asynchronous
   nameserver queries. I thknk GNOME does it, but
   that is probably LGPL'd (I'd like to keep
   nbcore w/ a bit more liberal copying policy) */

char sechost[1025]; /* MAXDNAME on some systems */
int sechostlen = 0;
struct in_addr secaddr = { 0 };
	
void nb_Resolve(NB_ResolveMsg * msg, char * host, int hostlen)
{
  struct hostent * he;

  if (hostlen > 1024)
    memset((char *)&msg->addr, 0, sizeof msg->addr);
  else {
    if (hostlen != sechostlen || memcmp(host, sechost, hostlen) != 0)
    {
      memcpy(sechost, host, hostlen);
      sechost[hostlen] = '\0';
      sechostlen = hostlen;

      if ((he = gethostbyname(sechost)) == NULL)
	memset((char *)&secaddr, 0, sizeof secaddr);
      else
	memcpy((char *)&secaddr, he->h_addr_list[0], sizeof secaddr);
    }
    msg->addr = secaddr;
  }
  
  nb_SendReplyMsg((NB_Msg *)msg);
}
