/*
 * $Id: prgutil.h $
 *
 * Author: Tomi Ollila <too@iki.fi>
 *
 * Created: Thu Mar 19 19:03:54 1998 too
 * Last modified: Sat Jul 11 14:12:50 1998 too
 *
 * HISTORY 
 * $Log: $
 */

#ifndef PRGUTIL_H
#define PRGUTIL_H

#ifndef F2S
#include "f2s.h"
#endif


typedef struct PRG_Args {
  struct PRG_Args * next;
  const char **	argtable;
  int 	(* argfunc)(/* PRG_Args * data, int n, int * argcp, char *** argvp */);
} PRG_Args;

/* Exit message structure is quite different, meant to be analogous to
 * init list, called in descending order to initialization, and is 
 * supposed to have data pointer done by initialization (if any)
 *
 * Now there is no init list, but main program has function calls to them..
 * They may add finalization functions to this list...
 */
/* currently these tools does not support finalizing subsystems */

typedef struct PRG_ExitMsg {
  struct PRG_ExitMsg * next;
  void	(* exitfunc)(struct PRG_ExitMsg *);
} PRG_ExitMsg;

void prg_AddArgList(PRG_Args * args);
void prg_AddExitMsg(PRG_ExitMsg * em);

int    arrstrstr(const char * stringarray[], const char * string);
char * have_next_arg(int * argcp, char ** argvp[]);
char * need_next_arg(int * argcp, char ** argvp[]);

int prg_ArgParse(int * argcp, char *** argvp);

void prg_Exit(int rv);


#endif /* PRGUTIL_H */
