/*
 * $Id: project.h,v 1.2 1996/06/27 13:42:24 too Exp $
 *
 * Author: Tomi Ollila <too@iki.fi>
 *
 * Created: Thu Aug 11 15:17:46 1994 too
 * Last modified: Mon Sep  7 19:20:40 1998 root
 *
 * HISTORY
 * $Log: project.h,v $
 */

#ifndef PROJECT_H
#define PROJECT_H

/*
 * Project spesific definitions...
 */

/* F2S, find pointer to structure when pointer to field is known */
#include "f2s.h"

#include "debugtools.h" /* TRACE etc. is needed everywhere */

#include "version.h" /* version information */


/*
 * Program spesific global constants after set (before any threading,
 * is some, is done)
 */

extern struct Program
{
  char * name;	/* required by ... */
  int port;
} P;

extern const char * const outofmem;


#define DBUFSIZE 16384 /* data buffer size */

void Exit(void);
void fatal(const char * format, ...);
void pfatal(const char * string);

#if defined (__sun__)
/* may use this is c library does not support stpcpy() */
static inline char * stpcpy(char * buf, char * str)
{
  int len = strlen(str);
  memcpy(buf, str, len);
  return buf + len;
}
#else  /* this code below may be defined in string.h */
char * stpcpy(char * dest, char * src);
#endif


/*
 * *************** below this line there is common definitions ***************
 */

/* would like to use `enum { FALSE = 0, TRUE = 1}', but ... */
#define FALSE 0
#define TRUE 1

#ifdef __cplusplus
#define NULL 0
#else
#define NULL (void*)0
#endif


#ifdef RCS_ID
#define RCID(x) static const char rcs_id[] = (x)
#else
#define RCID(x)
#endif

/* const here defined string stpcpy, advances buf argument ... */
#define CSTPCPY(buf, string) \
do{ int tmp = sizeof string -1; memcpy(buf, string, tmp); buf += tmp; }while(0)

#define CSTRCPY(buf, string) memcpy(buf, string, sizeof string - 1)

#define WriteCS(fd, string) write(fd, string, sizeof string - 1)

#define unless(x)	if (!(x))
#define until(x)	while (!(x))

#endif /* PROJECT_H */
