/*
 * $Id: serhdrtables.c $
 *
 * Author: Tomi Ollila <Tomi.Ollila@iki.fi>
 *
 * Created: Wed Aug 26 17:49:16 1998 too
 * Last modified: Mon Sep  7 19:21:39 1998 root
 *
 * HISTORY 
 * $Log: $
 */

#include "serhdrtables.h"

#define SL_(x) { x, sizeof x - 1 }

struct String serhdrtable[] = { /* same order than in enum list in hdr file */
  SL_(""), /* placeholder */
  SL_("HTTP/"),
  SL_("Server: "),
  SL_("MIME-version: "),
  SL_("Content-Type: "),
  SL_("Content-Length: "),
  SL_("Connection: "),
  SL_("Location: "),
  SL_("URI: "),
#if 0
  SL_(""),
#endif
};

#ifdef DEBUG
const int size_serhdrtable = sizeof serhdrtable / sizeof serhdrtable[0];
#endif

#define SL(x) x, sizeof x - 1

struct StringMap serhdrmaptable[] = {
#if 0
  { SL(" "), SM_ },
#endif
  /*
   * must be in alphaphetical order.
   */
  { SL("Connection: "), SM_CONN },
  { SL("Content-Length: "), SM_CONLEN },
  { SL("Content-Type: "), SM_CONTYPE },
  { SL("Content-length: "), SM_CONLEN },
  { SL("Content-type: "), SM_CONTYPE },
  { SL("HTTP/"), SM_HTTP },
  { SL("Location: "), SM_LOC },
  { SL("MIME-version: "), SM_MIMEVER },
  { SL("Server: "), SM_SERVER },
  { SL("URI: "), SM_URI },
};

const int serhdrmaptablelen = sizeof serhdrmaptable / sizeof serhdrmaptable[0];
