/*
 * $Id: tests.c $
 *
 * Author: Tomi Ollila <Tomi.Ollila@iki.fi>
 *
 * Created: Thu Aug 13 11:20:05 1998 too
 * Last modified: Mon Sep  7 19:59:49 1998 too
 *
 * HISTORY
 * $Log: $
 */

#ifdef DEBUG

#include <stdio.h>
#include <string.h>
#include "clihdrtables.h" /* for clihdr[map]table information */
#include "serhdrtables.h" /* for serhdr[map]table information */


#define myassert(a, b) do if (a != b) { \
fprintf(stderr, "Assertion failed: (%s == %d) != (%s == %d).\n", \
#a, a, #b, b); exit(0); } while (0)

static void testclihdrtables();
static void testserhdrtables();

void testprg()
{
  testclihdrtables();
  printf("\n");
  testserhdrtables();
  printf("\n\n");

#if 0 /* old */  
  myassert(amount_replymessages_en, RM_SIZE);
  myassert(amount_replymessages_fi, RM_SIZE);
  myassert(amount_httpreplycodes, RM_SIZE);
#endif  
}

static void testclihdrtables()
{
  int i;

  printf("size_clihdrtable == %d, clihdrmaptablelen == %d, CM_SIZE == %d \n",
	 size_clihdrtable, clihdrmaptablelen, CM_SIZE);

#if 0  
  if (size_clihdrtable <= clihdrmaptablelen)
  {
    printf("size_clihdrtable == %d <= clihdrmaptablelen == %d\n",
	   size_clihdrtable, clihdrmaptablelen);
    exit(0);
  }
#endif
  
  printf("There is an error, is there is a difference between right and left\n");


  for (i = 0; i < clihdrmaptablelen; i++)
  {
    char * f = "                    ";
    char * a = clihdrmaptable[i].string;
    int j = clihdrmaptable[i].value;
    char * b = clihdrtable[j].string;
    int l = 21 - strlen(a);
    
    printf("index %2d, enum %2d:  left = %s", i, j, a);
    printf("%.*s--  ", l, f);
    printf("right = %s\n", b);

    if (strcasecmp(a, b))
    {
      printf("Error above !!! \n");
      exit(0);
    }
  }
}

static void testserhdrtables()
{
  int i;

  printf("size_serhdrtable == %d, serhdrmaptablelen == %d, SM_SIZE == %d\n",
	 size_serhdrtable, serhdrmaptablelen, SM_SIZE);

#if 0   /* rather test that SM_SIZE matches serhdrtable */
  if (size_serhdrtable <= serhdrmaptablelen)
  {
    printf("size_serhdrtable == %d <= serhdrmaptablelen == %d\n",
	   size_serhdrtable, serhdrmaptablelen);
    exit(0);
  }
#endif
  
  printf("There is an error, is there is a difference between right and left\n");


  for (i = 0; i < serhdrmaptablelen; i++)
  {
    char * f = "                    ";
    char * a = serhdrmaptable[i].string;
    int j = serhdrmaptable[i].value;
    char * b = serhdrtable[j].string;
    int l = 21 - strlen(a);
    
    printf("index %2d, enum %2d:  left = %s", i, j, a);
    printf("%.*s--  ", l, f);
    printf("right = %s\n", b);

    if (strcasecmp(a, b))
    {
      printf("Error above !!! \n");
      exit(0);
    }
  }
}


#endif /* DEBUG */
